<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\ORM\EntityRepository;

class StructureType extends EntityRepository {

    function getStructureType($name = null ,$id= null,$organization){
        $entityManager = $this->getEntityManager();
        $query = $entityManager->createQueryBuilder()
            ->select('u')
            ->from('\\Model\\StructureType','u')
            ->where('u.organization = ?1')
            ->setParameter(1,$organization);
        if(!empty($name)){
            $query=$query->andWhere('u.name= ?2')
                ->setParameter(2,$name);
        }
        if(!empty($id)){
            $query=$query->andWhere('u.id = ?3')
                ->setParameter(3,$id);
        }
        $query=$query->getQuery()->execute();
        return $query;
    }

    function getStructureTypes($organizationId, $filterString = '') {
        $sql = <<<SQL
            SELECT ST.ID, ST.CONTROL, ST.LABEL
            FROM STRUCTURE_TYPE ST
            WHERE ST.ORGANIZATION = :organization
            AND (ST.CONTROL <> 'C' OR ST.CONTROL IS NULL)
            $filterString
SQL;

        $params = array(
            'organization' => $organizationId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }
}